diff --git a/src/postgres/src/backend/access/yb_access/yb_scan.c b/src/postgres/src/backend/access/yb_access/yb_scan.c
index 73e3c9dcee72..412352a12108 100644
--- a/src/postgres/src/backend/access/yb_access/yb_scan.c
+++ b/src/postgres/src/backend/access/yb_access/yb_scan.c
@@ -266,7 +266,7 @@ ybcBindTupleExprCondIn(YbScanDesc ybScan,
 	}
 
 	YBCPgExpr lhs =
-		YBCNewTupleExpr(ybScan->handle, &type_attrs, n_attnum_values, 
+		YBCNewTupleExpr(ybScan->handle, &type_attrs, n_attnum_values,
 						ybc_elems_exprs);
 
 	TupleDesc tupdesc = lookup_rowtype_tupdesc(tupType, tupTypmod);
@@ -289,7 +289,7 @@ ybcBindTupleExprCondIn(YbScanDesc ybScan,
 				YBEncodingCollation(ybScan->handle, attnum[j],
 									ybc_get_attcollation(bind_desc, attnum[j]));
 			ybc_elems_exprs[j] =
-				YBCNewConstant(ybScan->handle, atttypid, attcollation, 
+				YBCNewConstant(ybScan->handle, atttypid, attcollation,
 							   datum_values[j], is_null[j]);
 		}
 
@@ -730,7 +730,7 @@ YbIsEmptyResultCondition(int nkeys, ScanKey keys[])
 	for (int i = 0; i < nkeys; i++)
 	{
 		ScanKey key = keys[i];
-		
+
 		if (!((key->sk_flags & SK_ROW_MEMBER) && YbIsRowHeader(keys[i - 1])) ||
 			key->sk_strategy == BTEqualStrategyNumber)
 		{
@@ -1093,7 +1093,7 @@ YbBindRowComparisonKeys(YbScanDesc ybScan, YbScanPlan scan_plan,
 				* first column then we have to adjust the bounds on this
 				* column.
 				*/
-			if(!is_column_specified || 
+			if(!is_column_specified ||
 				(asc != is_direction_asc && !is_point_scan))
 			{
 				col_values[j] = NULL;
@@ -1186,7 +1186,7 @@ YbBindSearchArray(YbScanDesc ybScan, YbScanPlan scan_plan,
 		colids = palloc(sizeof(Oid) * subkey_count);
 		arrayval =
 			DatumGetArrayTypeP((ybScan->keys[i+1])->sk_argument);
-		
+
 		for(size_t j = 0; j < subkey_count; j++)
 		{
 			attnos[j] = ybScan->keys[i + j + 1]->sk_attno;
@@ -1203,7 +1203,7 @@ YbBindSearchArray(YbScanDesc ybScan, YbScanPlan scan_plan,
 	/* We could cache this data, but not clear it's worth it */
 	get_typlenbyvalalign(ARR_ELEMTYPE(arrayval), &elmlen,
 							&elmbyval, &elmalign);
-	
+
 	deconstruct_array(arrayval,
 					  ARR_ELEMTYPE(arrayval),
 					  elmlen, elmbyval, elmalign,
@@ -1213,7 +1213,7 @@ YbBindSearchArray(YbScanDesc ybScan, YbScanPlan scan_plan,
 	/*
 	 * Compress out any null elements.  We can ignore them since we assume
 	 * all btree operators are strict.
-	 * Also remove elements that are too large or too small. 
+	 * Also remove elements that are too large or too small.
 	 * eg. WHERE element = INT_MAX + k, where k is positive and element
 	 * is of integer type.
 	 */
@@ -1233,8 +1233,8 @@ YbBindSearchArray(YbScanDesc ybScan, YbScanPlan scan_plan,
 			continue;
 
 		/* Skip any rows that have NULLs in them. */
-		/* 
-		 * TODO: record_eq considers NULL record elements to 
+		/*
+		 * TODO: record_eq considers NULL record elements to
 		 * be equal. However, the only way we receive IN filters
 		 * with tuples is through
 		 * compound batched nested loop joins where NULL
@@ -1473,7 +1473,7 @@ YbBindScanKeys(YbScanDesc ybScan, YbScanPlan scan_plan)
 				else if (YbIsSearchArray(key))
 				{
 					bool bail_out = false;
-					bool is_bound = 
+					bool is_bound =
 						YbBindSearchArray(ybScan, scan_plan,
 										  i, is_column_bound,
 									  	  &bail_out);
@@ -1819,7 +1819,7 @@ ybcSetupTargets(YbScanDesc ybScan, YbScanPlan scan_plan, Scan *pg_scan_plan)
 		target_added = true;
 	}
 
-	if (is_index_only_scan) 
+	if (is_index_only_scan)
 	{
 		/*
 		 * In the case of IndexOnlyScan with no targets, we need to set a
@@ -2089,6 +2089,26 @@ ybc_keys_match(HeapTuple tup, YbScanDesc ybScan, bool *recheck)
 	return true;
 }
 
+static bool
+is_index_functional(Relation index)
+{
+	if (!index->rd_indexprs)
+		return false;
+
+	ListCell   *indexpr_item;
+
+	foreach(indexpr_item, index->rd_indexprs)
+	{
+		Expr    *indexvar = (Expr *) lfirst(indexpr_item);
+		if (IsA(indexvar, FuncExpr))
+		{
+			return true;
+		}
+
+	}
+	return false;
+}
+
 HeapTuple
 ybc_getnext_heaptuple(YbScanDesc ybScan, bool is_forward_scan,
 					  bool *recheck)
@@ -2098,12 +2118,17 @@ ybc_getnext_heaptuple(YbScanDesc ybScan, bool is_forward_scan,
 	if (ybScan->quit_scan)
 		return NULL;
 
-	/* In case of yb_hash_code pushdown tuple must be rechecked */
+	/* In case of yb_hash_code pushdown tuple must be rechecked. */
 	bool tuple_recheck_required = (ybScan->nhash_keys > 0);
+
+	/* If the index is on a function, we need to recheck. */
+	if (ybScan->index)
+		tuple_recheck_required |= is_index_functional(ybScan->index);
+
 	/*
-	* YB Scan may not be able to push down the scan key condition so we may
-	* need additional filtering here.
-	*/
+	 * YB Scan may not be able to push down the scan key condition so we may
+	 * need additional filtering here.
+	 */
 	while (HeapTupleIsValid(tup = ybcFetchNextHeapTuple(ybScan, is_forward_scan)))
 	{
 		if (tuple_recheck_required)
@@ -2131,7 +2156,7 @@ ybc_getnext_indextuple(YbScanDesc ybScan, bool is_forward_scan, bool *recheck)
 	if (ybScan->quit_scan)
 		return NULL;
 
-	/* 
+	/*
 	 * If we have a yb_hash_code pushdown or not all conditions were
 	 * bound tuple must be rechecked.
 	 */
diff --git a/src/postgres/src/backend/optimizer/path/indxpath.c b/src/postgres/src/backend/optimizer/path/indxpath.c
index dbf6bce24935..91f43879e98c 100644
--- a/src/postgres/src/backend/optimizer/path/indxpath.c
+++ b/src/postgres/src/backend/optimizer/path/indxpath.c
@@ -2415,6 +2415,55 @@ static bool is_yb_hash_code_call(Node *clause)
 				&& (((FuncExpr *) clause)->funcid == YB_HASH_CODE_OID);
 }
 
+
+/*
+ * yb_hash_code_call_matches_indexcol
+ * 	  Returns true if the index is on yb_hash_code(a, b, ...) and this index column is
+ *	  a matching yb_hash_code(a, b, ...) clause.
+ */
+static bool
+yb_hash_code_call_matches_indexcol(Node *yb_hash_code_clause,
+								   IndexOptInfo *index,
+								   int indexcol)
+{
+	if (!index->indexprs)
+		return false;
+	int			pos;
+	ListCell   *indexpr_item;
+
+	/* Iterate over each column of the index until the column of interest. */
+	indexpr_item = list_head(index->indexprs);
+	for (pos = 0; pos <= indexcol; pos++)
+	{
+		if (index->indexkeys[pos] == 0)
+		{
+			/* The index column refers to the next expression of indexprs. */
+			Node	   *indexkey;
+
+			if (indexpr_item == NULL)
+			{
+				elog(WARNING, "too few entries in indexprs list");
+				return false;
+			}
+
+			if (pos == indexcol)
+			{
+				indexkey = (Node *) lfirst(indexpr_item);
+				if (indexkey && IsA(indexkey, RelabelType))
+						indexkey = (Node *) ((RelabelType *) indexkey)->arg;
+				if (equal(yb_hash_code_clause, indexkey))
+				{
+					return true;
+				}
+			}
+
+			indexpr_item = lnext(indexpr_item);
+		}
+	}
+
+	return false;
+}
+
 /*
  * match_clause_to_indexcol()
  *	  Determines whether a restriction clause matches a column of an index.
@@ -2552,8 +2601,8 @@ match_clause_to_indexcol(IndexOptInfo *index,
 		if (!nt->argisrow &&
 			match_index_to_operand((Node *) nt->arg, indexcol, index)) {
 				/* Cannot push down IS NOT NULL on hash columns in LSM Index */
-				if (IsYBRelationById(index->indexoid) && 
-				    nt->nulltesttype == IS_NOT_NULL && 
+				if (IsYBRelationById(index->indexoid) &&
+				    nt->nulltesttype == IS_NOT_NULL &&
 					is_hash_column_in_lsm_index(index, indexcol))
 					return false;
 				return true;
@@ -2571,14 +2620,20 @@ match_clause_to_indexcol(IndexOptInfo *index,
 		!bms_is_member(index_relid, right_relids) &&
 		!contain_volatile_functions(rightop))
 	{
-		if (is_yb_hash_code_call(leftop)) {
-				return is_indexable_operator(expr_op,
-							INTEGER_LSM_FAM_OID, true)
-						&& is_opclause(clause);
+		/*
+		 * Do not use the yb_hash_code special case if we have an applicable
+		 * functional index on yb_hash_code. For example, if the call is an
+		 * index on yb_hash_code(x, y) and the clause is yb_hash_code(x, y),
+		 * we will take the typical index path.
+		 */
+		if (is_yb_hash_code_call(leftop) &&
+			!yb_hash_code_call_matches_indexcol(leftop, index, indexcol)) {
+			return is_indexable_operator(expr_op, INTEGER_LSM_FAM_OID, true)
+				&& is_opclause(clause);
 		}
 
 		/*
-		 * If the column in the filter clause is part of the hash key for this 
+		 * If the column in the filter clause is part of the hash key for this
 		 * index and the clause uses an inequality operator, then index scan
 		 * cannot be used. This is because a hash index is sorted by the hash
 		 * value and not by the value of the column. #13241
@@ -2610,14 +2665,20 @@ match_clause_to_indexcol(IndexOptInfo *index,
 		!bms_is_member(index_relid, left_relids) &&
 		!contain_volatile_functions(leftop))
 	{
-		if (is_yb_hash_code_call(rightop)) {
-				return is_indexable_operator(expr_op,
-							INTEGER_LSM_FAM_OID, true)
-						&& is_opclause(clause);
+		/*
+		 * Do not use the yb_hash_code special case if we have an applicable
+		 * functional index on yb_hash_code. For example, if the call is an
+		 * index on yb_hash_code(x, y) and the clause is yb_hash_code(x, y),
+		 * we will take the typical index path.
+		 */
+		if (is_yb_hash_code_call(rightop) &&
+			!yb_hash_code_call_matches_indexcol(rightop, index, indexcol)) {
+			return is_indexable_operator(expr_op, INTEGER_LSM_FAM_OID, false)
+				&& is_opclause(clause);
 		}
 
 		/*
-		 * If the column in the filter clause is part of the hash key for this 
+		 * If the column in the filter clause is part of the hash key for this
 		 * index and the clause uses an inequality operator, then index scan
 		 * cannot be used. This is because a hash index is sorted by the hash
 		 * value and not by the value of the column. #13241
@@ -3510,7 +3571,7 @@ match_index_to_operand(Node *operand,
 		/*
 		 * Simple index column; operand must be a matching Var
 		 */
-		
+
 		Var *operand_var = NULL;
 		if (operand && IsA(operand, Var))
 			operand_var = (Var *) operand;
@@ -4634,8 +4695,8 @@ string_to_const(const char *str, Oid datatype)
 					 conval, false, false);
 }
 
-static bool 
-is_hash_column_in_lsm_index(const IndexOptInfo* index, int columnIndex) 
+static bool
+is_hash_column_in_lsm_index(const IndexOptInfo* index, int columnIndex)
 {
 	return (index->relam == LSM_AM_OID && columnIndex < index->nhashcolumns);
 }
diff --git a/src/postgres/src/test/regress/expected/yb_functional_index_multiple_column.out b/src/postgres/src/test/regress/expected/yb_functional_index_multiple_column.out
new file mode 100644
index 000000000000..aa8dde08a557
--- /dev/null
+++ b/src/postgres/src/test/regress/expected/yb_functional_index_multiple_column.out
@@ -0,0 +1,652 @@
+CREATE TABLE t AS SELECT x, x AS y, x AS z FROM generate_series(1, 10) x;
+CREATE INDEX t_hcx_hash_y_hash_idx ON t ((yb_hash_code(x), y) HASH);
+-- Query #2 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x) < 4000)
+   Rows Removed by Filter: 5
+   Remote Filter: (y > 4)
+(4 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+                                 QUERY PLAN
+-----------------------------------------------------------------------------
+ Index Scan using t_hcx_hash_y_hash_idx on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) = 2675) AND (y = ANY ('{5,6}'::integer[])))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6); -- this one uses index successfully on master (because it has recheck)
+                               QUERY PLAN
+-------------------------------------------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: ((y = ANY ('{5,6}'::integer[])) AND (yb_hash_code(x) < 4000))
+   Rows Removed by Filter: 9
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x) = 2675)
+   Rows Removed by Filter: 5
+   Remote Filter: (y > 4)
+(4 rows)
+
+DROP INDEX t_hcx_hash_y_hash_idx;
+CREATE INDEX t_hcx_asc_y_asc_idx ON t (yb_hash_code(x) ASC, y ASC);
+-- These should all use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+                            QUERY PLAN
+-------------------------------------------------------------------
+ Index Scan using t_hcx_asc_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) < 4000) AND (y > 4))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+                                 QUERY PLAN
+-----------------------------------------------------------------------------
+ Index Scan using t_hcx_asc_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) = 2675) AND (y = ANY ('{5,6}'::integer[])))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+                                 QUERY PLAN
+-----------------------------------------------------------------------------
+ Index Scan using t_hcx_asc_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) < 4000) AND (y = ANY ('{5,6}'::integer[])))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+                            QUERY PLAN
+-------------------------------------------------------------------
+ Index Scan using t_hcx_asc_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) = 2675) AND (y > 4))
+(2 rows)
+
+DROP INDEX t_hcx_asc_y_asc_idx;
+CREATE INDEX t_hcx_hash_y_asc_idx ON t (yb_hash_code(x) HASH, y ASC);
+-- Query #2 and #4 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x) < 4000)
+   Rows Removed by Filter: 5
+   Remote Filter: (y > 4)
+(4 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+                                 QUERY PLAN
+-----------------------------------------------------------------------------
+ Index Scan using t_hcx_hash_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) = 2675) AND (y = ANY ('{5,6}'::integer[])))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+                               QUERY PLAN
+-------------------------------------------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: ((y = ANY ('{5,6}'::integer[])) AND (yb_hash_code(x) < 4000))
+   Rows Removed by Filter: 9
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+                             QUERY PLAN
+--------------------------------------------------------------------
+ Index Scan using t_hcx_hash_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) = 2675) AND (y > 4))
+(2 rows)
+
+DROP INDEX t_hcx_hash_y_asc_idx;
+CREATE INDEX t_y_hash_hcx_asc_idx ON t (y HASH, yb_hash_code(x) ASC);
+-- Query #2 and #3 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x) < 4000)
+   Rows Removed by Filter: 5
+   Remote Filter: (y > 4)
+(4 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+                                 QUERY PLAN
+-----------------------------------------------------------------------------
+ Index Scan using t_y_hash_hcx_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((y = ANY ('{5,6}'::integer[])) AND (yb_hash_code(x) = 2675))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+                                 QUERY PLAN
+-----------------------------------------------------------------------------
+ Index Scan using t_y_hash_hcx_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((y = ANY ('{5,6}'::integer[])) AND (yb_hash_code(x) < 4000))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x) = 2675)
+   Rows Removed by Filter: 5
+   Remote Filter: (y > 4)
+(4 rows)
+
+DROP INDEX t_y_hash_hcx_asc_idx;
+CREATE INDEX t_cbrtx_hash_y_hash_idx ON t ((cbrt(x), y) HASH);
+-- Query #2 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y < 2;
+                                       QUERY PLAN
+----------------------------------------------------------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Remote Filter: ((y < 2) AND (cbrt((x)::double precision) < '1.2'::double precision))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y = 1;
+                                    QUERY PLAN
+-----------------------------------------------------------------------------------
+ Index Scan using t_cbrtx_hash_y_hash_idx on t (actual rows=1 loops=1)
+   Index Cond: ((cbrt((x)::double precision) = '1'::double precision) AND (y = 1))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y = 1;
+                                       QUERY PLAN
+----------------------------------------------------------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Remote Filter: ((y = 1) AND (cbrt((x)::double precision) < '1.2'::double precision))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y < 2;
+                                      QUERY PLAN
+--------------------------------------------------------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Remote Filter: ((y < 2) AND (cbrt((x)::double precision) = '1'::double precision))
+(2 rows)
+
+DROP INDEX t_cbrtx_hash_y_hash_idx;
+CREATE INDEX t_cbrtx_asc_y_asc_idx ON t (cbrt(x) ASC, y ASC);
+-- These should all use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y < 2;
+                                     QUERY PLAN
+-------------------------------------------------------------------------------------
+ Index Scan using t_cbrtx_asc_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((cbrt((x)::double precision) < '1.2'::double precision) AND (y < 2))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y = 1;
+                                    QUERY PLAN
+-----------------------------------------------------------------------------------
+ Index Scan using t_cbrtx_asc_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((cbrt((x)::double precision) = '1'::double precision) AND (y = 1))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y = 1;
+                                     QUERY PLAN
+-------------------------------------------------------------------------------------
+ Index Scan using t_cbrtx_asc_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((cbrt((x)::double precision) < '1.2'::double precision) AND (y = 1))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y < 2;
+                                    QUERY PLAN
+-----------------------------------------------------------------------------------
+ Index Scan using t_cbrtx_asc_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((cbrt((x)::double precision) = '1'::double precision) AND (y < 2))
+(2 rows)
+
+DROP INDEX t_cbrtx_asc_y_asc_idx;
+CREATE INDEX t_cbrtx_hash_y_asc_idx ON t (cbrt(x) HASH, y ASC);
+-- Query #2 and #4 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y < 2;
+                                       QUERY PLAN
+----------------------------------------------------------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Remote Filter: ((y < 2) AND (cbrt((x)::double precision) < '1.2'::double precision))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y = 1;
+                                    QUERY PLAN
+-----------------------------------------------------------------------------------
+ Index Scan using t_cbrtx_hash_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((cbrt((x)::double precision) = '1'::double precision) AND (y = 1))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y = 1;
+                                       QUERY PLAN
+----------------------------------------------------------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Remote Filter: ((y = 1) AND (cbrt((x)::double precision) < '1.2'::double precision))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y < 2;
+                                    QUERY PLAN
+-----------------------------------------------------------------------------------
+ Index Scan using t_cbrtx_hash_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((cbrt((x)::double precision) = '1'::double precision) AND (y < 2))
+(2 rows)
+
+DROP INDEX t_cbrtx_hash_y_asc_idx;
+CREATE INDEX t_y_hash_cbrtx_asc_idx ON t (y HASH, cbrt(x) ASC);
+-- Query #2 and #3 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y < 2;
+                                       QUERY PLAN
+----------------------------------------------------------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Remote Filter: ((y < 2) AND (cbrt((x)::double precision) < '1.2'::double precision))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y = 1;
+                                    QUERY PLAN
+-----------------------------------------------------------------------------------
+ Index Scan using t_y_hash_cbrtx_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((y = 1) AND (cbrt((x)::double precision) = '1'::double precision))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y = 1;
+                                     QUERY PLAN
+-------------------------------------------------------------------------------------
+ Index Scan using t_y_hash_cbrtx_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((y = 1) AND (cbrt((x)::double precision) < '1.2'::double precision))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y < 2;
+                                      QUERY PLAN
+--------------------------------------------------------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Remote Filter: ((y < 2) AND (cbrt((x)::double precision) = '1'::double precision))
+(2 rows)
+
+DROP INDEX t_y_hash_cbrtx_asc_idx;
+CREATE INDEX t_x_hash_y_hash_idx ON t ((x, y) HASH);
+-- Query #2 should be able to use the index, but doesn't (even before this diff)
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x) < 4000)
+   Rows Removed by Filter: 5
+   Remote Filter: (y > 4)
+(4 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+                               QUERY PLAN
+-------------------------------------------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: ((y = ANY ('{5,6}'::integer[])) AND (yb_hash_code(x) = 2675))
+   Rows Removed by Filter: 9
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+                               QUERY PLAN
+-------------------------------------------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: ((y = ANY ('{5,6}'::integer[])) AND (yb_hash_code(x) < 4000))
+   Rows Removed by Filter: 9
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x) = 2675)
+   Rows Removed by Filter: 5
+   Remote Filter: (y > 4)
+(4 rows)
+
+DROP INDEX t_x_hash_y_hash_idx;
+CREATE INDEX t_x_hash_y_asc_idx ON t (x HASH, y ASC);
+-- All should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+                              QUERY PLAN
+-----------------------------------------------------------------------
+ Index Only Scan using t_x_hash_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) < 4000) AND (y > 4))
+   Heap Fetches: 0
+(3 rows)
+
+-- EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6); -- TODO: #17043
+-- EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6); -- TODO: #17043
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+                              QUERY PLAN
+-----------------------------------------------------------------------
+ Index Only Scan using t_x_hash_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) = 2675) AND (y > 4))
+   Heap Fetches: 0
+(3 rows)
+
+DROP INDEX t_x_hash_y_asc_idx;
+CREATE INDEX t_y_hash_x_asc_idx ON t (y HASH, x ASC);
+-- Query #2 and #3 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x) < 4000)
+   Rows Removed by Filter: 5
+   Remote Filter: (y > 4)
+(4 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+                              QUERY PLAN
+-----------------------------------------------------------------------
+ Index Only Scan using t_y_hash_x_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: (y = ANY ('{5,6}'::integer[]))
+   Filter: (yb_hash_code(x) = 2675)
+   Rows Removed by Filter: 1
+   Heap Fetches: 0
+(5 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+                              QUERY PLAN
+-----------------------------------------------------------------------
+ Index Only Scan using t_y_hash_x_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: (y = ANY ('{5,6}'::integer[]))
+   Filter: (yb_hash_code(x) < 4000)
+   Rows Removed by Filter: 1
+   Heap Fetches: 0
+(5 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x) = 2675)
+   Rows Removed by Filter: 5
+   Remote Filter: (y > 4)
+(4 rows)
+
+DROP INDEX t_y_hash_x_asc_idx;
+CREATE INDEX t_x_asc_y_asc_idx ON t (x ASC, y ASC);
+-- These should all use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+                              QUERY PLAN
+----------------------------------------------------------------------
+ Index Only Scan using t_x_asc_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: (y > 4)
+   Filter: (yb_hash_code(x) < 4000)
+   Rows Removed by Filter: 5
+   Heap Fetches: 0
+(5 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+                              QUERY PLAN
+----------------------------------------------------------------------
+ Index Only Scan using t_x_asc_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: (y = ANY ('{5,6}'::integer[]))
+   Filter: (yb_hash_code(x) = 2675)
+   Rows Removed by Filter: 1
+   Heap Fetches: 0
+(5 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+                              QUERY PLAN
+----------------------------------------------------------------------
+ Index Only Scan using t_x_asc_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: (y = ANY ('{5,6}'::integer[]))
+   Filter: (yb_hash_code(x) < 4000)
+   Rows Removed by Filter: 1
+   Heap Fetches: 0
+(5 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+                              QUERY PLAN
+----------------------------------------------------------------------
+ Index Only Scan using t_x_asc_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: (y > 4)
+   Filter: (yb_hash_code(x) = 2675)
+   Rows Removed by Filter: 5
+   Heap Fetches: 0
+(5 rows)
+
+DROP INDEX t_x_asc_y_asc_idx;
+CREATE INDEX t_x_hash_y_hashcode ON t (x HASH, yb_hash_code(y));
+-- These should all be able to use the index, with queries #1-4 needing to filter to satisfy the y constraint
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+                            QUERY PLAN
+-------------------------------------------------------------------
+ Index Scan using t_x_hash_y_hashcode on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(x) < 4000)
+   Remote Filter: (y > 4)
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+                            QUERY PLAN
+-------------------------------------------------------------------
+ Index Scan using t_x_hash_y_hashcode on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(x) = 2675)
+   Filter: (y = ANY ('{5,6}'::integer[]))
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+                            QUERY PLAN
+-------------------------------------------------------------------
+ Index Scan using t_x_hash_y_hashcode on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(x) < 4000)
+   Filter: (y = ANY ('{5,6}'::integer[]))
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+                            QUERY PLAN
+-------------------------------------------------------------------
+ Index Scan using t_x_hash_y_hashcode on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(x) = 2675)
+   Remote Filter: (y > 4)
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y) FROM t WHERE yb_hash_code(x) < 4000 AND yb_hash_code(y) > 4;
+                             QUERY PLAN
+--------------------------------------------------------------------
+ Index Scan using t_x_hash_y_hashcode on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) < 4000) AND (yb_hash_code(y) > 4))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y) FROM t WHERE yb_hash_code(x) = 2675 AND yb_hash_code(y) = 2675;
+                              QUERY PLAN
+-----------------------------------------------------------------------
+ Index Scan using t_x_hash_y_hashcode on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) = 2675) AND (yb_hash_code(y) = 2675))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y) FROM t WHERE yb_hash_code(x) < 4000 AND yb_hash_code(y) = 2675;
+                              QUERY PLAN
+-----------------------------------------------------------------------
+ Index Scan using t_x_hash_y_hashcode on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) < 4000) AND (yb_hash_code(y) = 2675))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y) FROM t WHERE yb_hash_code(x) = 2675 AND yb_hash_code(y) > 4;
+                             QUERY PLAN
+--------------------------------------------------------------------
+ Index Scan using t_x_hash_y_hashcode on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) = 2675) AND (yb_hash_code(y) > 4))
+(2 rows)
+
+DROP INDEX t_x_hash_y_hashcode;
+CREATE INDEX t_x_hash_yz_hashcode ON t (x HASH, yb_hash_code(y, z));
+-- These should all be able to use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000;
+                             QUERY PLAN
+--------------------------------------------------------------------
+ Index Scan using t_x_hash_yz_hashcode on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(x) < 4000)
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675;
+                             QUERY PLAN
+--------------------------------------------------------------------
+ Index Scan using t_x_hash_yz_hashcode on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(x) = 2675)
+(2 rows)
+
+-- These should be all be able to use the index, with a filter to satisfy the y constraint
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+                             QUERY PLAN
+--------------------------------------------------------------------
+ Index Scan using t_x_hash_yz_hashcode on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(x) < 4000)
+   Remote Filter: (y > 4)
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+                             QUERY PLAN
+--------------------------------------------------------------------
+ Index Scan using t_x_hash_yz_hashcode on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(x) = 2675)
+   Filter: (y = ANY ('{5,6}'::integer[]))
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+                             QUERY PLAN
+--------------------------------------------------------------------
+ Index Scan using t_x_hash_yz_hashcode on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(x) < 4000)
+   Filter: (y = ANY ('{5,6}'::integer[]))
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+                             QUERY PLAN
+--------------------------------------------------------------------
+ Index Scan using t_x_hash_yz_hashcode on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(x) = 2675)
+   Remote Filter: (y > 4)
+(3 rows)
+
+-- These should all be able to use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y, z) FROM t WHERE yb_hash_code(x) > 40000 AND yb_hash_code(y, z) < 2500;
+                                QUERY PLAN
+---------------------------------------------------------------------------
+ Index Scan using t_x_hash_yz_hashcode on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) > 40000) AND (yb_hash_code(y, z) < 2500))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y, z) FROM t WHERE yb_hash_code(x) = 40623 AND yb_hash_code(y, z) = 2181;
+                                QUERY PLAN
+---------------------------------------------------------------------------
+ Index Scan using t_x_hash_yz_hashcode on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) = 40623) AND (yb_hash_code(y, z) = 2181))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y, z) FROM t WHERE yb_hash_code(x) > 40000 AND yb_hash_code(y, z) < 2500;
+                                QUERY PLAN
+---------------------------------------------------------------------------
+ Index Scan using t_x_hash_yz_hashcode on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) > 40000) AND (yb_hash_code(y, z) < 2500))
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y, z) FROM t WHERE yb_hash_code(x) = 40623 AND yb_hash_code(y, z) = 2181;
+                                QUERY PLAN
+---------------------------------------------------------------------------
+ Index Scan using t_x_hash_yz_hashcode on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) = 40623) AND (yb_hash_code(y, z) = 2181))
+(2 rows)
+
+DROP INDEX t_x_hash_yz_hashcode;
+CREATE INDEX t_xy_yb_hash_code ON t (yb_hash_code(x, y));
+-- Of the following, only the query with an equality clause on yb_hash_code(x, y) should be able to use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x, x) FROM t WHERE yb_hash_code(x, x) = 2181;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x, x) = 2181)
+   Rows Removed by Filter: 9
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x, x) FROM t WHERE yb_hash_code(x, x) < 2500;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x, x) < 2500)
+   Rows Removed by Filter: 9
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x, y) FROM t WHERE yb_hash_code(x, y) = 2181;
+                           QUERY PLAN
+-----------------------------------------------------------------
+ Index Scan using t_xy_yb_hash_code on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(x, y) = 2181)
+(2 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x, y) FROM t WHERE yb_hash_code(x, y) < 2500;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x, y) < 2500)
+   Rows Removed by Filter: 9
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(y, x) FROM t WHERE yb_hash_code(y, x) = 2181;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(y, x) = 2181)
+   Rows Removed by Filter: 9
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(y, x) FROM t WHERE yb_hash_code(y, x) < 2500;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(y, x) < 2500)
+   Rows Removed by Filter: 9
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(y, y) FROM t WHERE yb_hash_code(y, y) = 2181;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(y, y) = 2181)
+   Rows Removed by Filter: 9
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(y, y) FROM t WHERE yb_hash_code(y, y) < 2500;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(y, y) < 2500)
+   Rows Removed by Filter: 9
+(3 rows)
+
+DROP INDEX t_xy_yb_hash_code;
+-- In general, a query on yb_hash_code(x) < 4000 could use either the (x HASH)
+-- column of the index or the (yb_hash_code(x) ASC) part of the index.
+-- We want to ensure that both are allowed, and the presence of one does not
+-- forbid the use of the other. In this index, even though we have yb_hash_code(x|y) columns,
+-- we won't use them because the index is ordered by (x HASH, y ASC) first.
+CREATE INDEX t_complex_idx ON t (y HASH, y ASC, yb_hash_code(x) ASC, yb_hash_code(y) ASC);
+-- These queries will not use the index because yb_hash_code(x) is too deep in the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x) FROM t WHERE yb_hash_code(x) < 4000;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x) < 4000)
+   Rows Removed by Filter: 9
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x) FROM t WHERE yb_hash_code(x) = 2675;
+              QUERY PLAN
+---------------------------------------
+ Seq Scan on t (actual rows=1 loops=1)
+   Filter: (yb_hash_code(x) = 2675)
+   Rows Removed by Filter: 9
+(3 rows)
+
+-- These queries will use the index because the (y HASH) column can answer the query.
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(y) FROM t WHERE yb_hash_code(y) < 4000;
+                            QUERY PLAN
+------------------------------------------------------------------
+ Index Only Scan using t_complex_idx on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(y) < 4000)
+   Heap Fetches: 0
+(3 rows)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(y) FROM t WHERE yb_hash_code(y) = 2675;
+                            QUERY PLAN
+------------------------------------------------------------------
+ Index Only Scan using t_complex_idx on t (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(y) = 2675)
+   Heap Fetches: 0
+(3 rows)
+
+DROP TABLE t;
diff --git a/src/postgres/src/test/regress/expected/yb_functional_indexes.out b/src/postgres/src/test/regress/expected/yb_functional_indexes.out
new file mode 100644
index 000000000000..86ea126c474b
--- /dev/null
+++ b/src/postgres/src/test/regress/expected/yb_functional_indexes.out
@@ -0,0 +1,664 @@
+CREATE TABLE test_with_pk (a INT PRIMARY KEY, h INT);
+INSERT INTO test_with_pk SELECT x, x FROM generate_series(1, 10) x;
+-- This test verifies:
+--  * yb_hash_code range queries
+--  * yb_hash_code equality queries
+--  * cbrt range queries
+--  * cbrt equality queries
+-- on the following cases
+--  * on the primary key
+--  * on a regular column
+--  * on a regular column that has a hash index
+--  * on a regular column that has an asc index
+--  * on a regular column that has a hash index on yb_hash_code and a hash
+--    index on cbrt
+--  * on a regular column that has an asc index on yb_hash_code and an asc
+--    index on cbrt
+-- cbrt was selected as an example of a simple, standard function, not because
+-- of any special attributes. For each of these 4 * 6 cases, they are tested
+-- with seqscans disabled and with seqscans enabled. This documents their
+-- preferred plan, and also ensures that if the query planner allows them to
+-- use an index, the result is still correct.
+---- PRIMARY KEY ----
+SET enable_seqscan = false;
+-- we can pushdown the yb_hash_code call to the pk index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) < 4000;
+                                 QUERY PLAN
+----------------------------------------------------------------------------
+ Index Scan using test_with_pk_pkey on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(a) < 4000)
+(2 rows)
+
+SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) < 4000;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+-- we can pushdown the yb_hash_code call to the pk index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) = 2675;
+                                 QUERY PLAN
+----------------------------------------------------------------------------
+ Index Scan using test_with_pk_pkey on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(a) = 2675)
+(2 rows)
+
+SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) = 2675;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) < 1.2;
+                                QUERY PLAN
+--------------------------------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((a)::double precision) < '1.2'::double precision)
+(2 rows)
+
+SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) < 1.2;
+ cbrt
+------
+    1
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) = 1;
+                               QUERY PLAN
+------------------------------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((a)::double precision) = '1'::double precision)
+(2 rows)
+
+SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) = 1;
+ cbrt
+------
+    1
+(1 row)
+
+SET enable_seqscan = true;
+-- we can pushdown the yb_hash_code call to the pk index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) < 4000;
+                                 QUERY PLAN
+----------------------------------------------------------------------------
+ Index Scan using test_with_pk_pkey on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(a) < 4000)
+(2 rows)
+
+SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) < 4000;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+-- we can pushdown the yb_hash_code call to the pk index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) = 2675;
+                                 QUERY PLAN
+----------------------------------------------------------------------------
+ Index Scan using test_with_pk_pkey on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(a) = 2675)
+(2 rows)
+
+SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) = 2675;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) < 1.2;
+                                QUERY PLAN
+--------------------------------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((a)::double precision) < '1.2'::double precision)
+(2 rows)
+
+SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) < 1.2;
+ cbrt
+------
+    1
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) = 1;
+                               QUERY PLAN
+------------------------------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((a)::double precision) = '1'::double precision)
+(2 rows)
+
+SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) = 1;
+ cbrt
+------
+    1
+(1 row)
+
+---- REGULAR COLUMN ----
+SET enable_seqscan = false;
+-- for these queries, we use seqscan (even when disabled)
+-- because there is no other option
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+                    QUERY PLAN
+--------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Filter: (yb_hash_code(h) < 4000)
+   Rows Removed by Filter: 9
+(3 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+                    QUERY PLAN
+--------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Filter: (yb_hash_code(h) = 2675)
+   Rows Removed by Filter: 9
+(3 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+                                QUERY PLAN
+--------------------------------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((h)::double precision) < '1.2'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+ cbrt
+------
+    1
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+                               QUERY PLAN
+------------------------------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((h)::double precision) = '1'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+ cbrt
+------
+    1
+(1 row)
+
+---- HASH INDEX ON THE COLUMN ----
+CREATE INDEX t_b_hash_idx ON test_with_pk(h);
+SET enable_seqscan = false;
+-- we can pushdown yb_hash_code(h) on a hash index on h because the index is ordered by hash code
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+                                 QUERY PLAN
+----------------------------------------------------------------------------
+ Index Only Scan using t_b_hash_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(h) < 4000)
+   Heap Fetches: 0
+(3 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+-- we can pushdown yb_hash_code(h) on a hash index on h because the index is ordered by hash code
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+                                 QUERY PLAN
+----------------------------------------------------------------------------
+ Index Only Scan using t_b_hash_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(h) = 2675)
+   Heap Fetches: 0
+(3 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+                                 QUERY PLAN
+----------------------------------------------------------------------------
+ Index Only Scan using t_b_hash_idx on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((h)::double precision) < '1.2'::double precision)
+   Heap Fetches: 0
+(3 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+ cbrt
+------
+    1
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+                                 QUERY PLAN
+----------------------------------------------------------------------------
+ Index Only Scan using t_b_hash_idx on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((h)::double precision) = '1'::double precision)
+   Heap Fetches: 0
+(3 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+ cbrt
+------
+    1
+(1 row)
+
+SET enable_seqscan = true;
+-- we prefer using the index over a seq scan
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+                                 QUERY PLAN
+----------------------------------------------------------------------------
+ Index Only Scan using t_b_hash_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(h) < 4000)
+   Heap Fetches: 0
+(3 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+-- we prefer using the index over a seq scan
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+                                 QUERY PLAN
+----------------------------------------------------------------------------
+ Index Only Scan using t_b_hash_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(h) = 2675)
+   Heap Fetches: 0
+(3 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+                                QUERY PLAN
+--------------------------------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((h)::double precision) < '1.2'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+ cbrt
+------
+    1
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+                               QUERY PLAN
+------------------------------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((h)::double precision) = '1'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+ cbrt
+------
+    1
+(1 row)
+
+---- ASC INDEX ON THE COLUMN ----
+DROP INDEX t_b_hash_idx;
+CREATE INDEX t_b_asc_idx ON test_with_pk(h ASC);
+SET enable_seqscan = false;
+-- cannot pushdown a range yb_hash_code(h) clause on a ascending index on h because the index is not ordered by hash code
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+                                QUERY PLAN
+---------------------------------------------------------------------------
+ Index Only Scan using t_b_asc_idx on test_with_pk (actual rows=1 loops=1)
+   Filter: (yb_hash_code(h) < 4000)
+   Rows Removed by Filter: 9
+   Heap Fetches: 0
+(4 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+-- cannot pushdown an equality yb_hash_code(h) clause on a ascending index on h because the index is not ordered by hash code
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+                                QUERY PLAN
+---------------------------------------------------------------------------
+ Index Only Scan using t_b_asc_idx on test_with_pk (actual rows=1 loops=1)
+   Filter: (yb_hash_code(h) = 2675)
+   Rows Removed by Filter: 9
+   Heap Fetches: 0
+(4 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+                                QUERY PLAN
+---------------------------------------------------------------------------
+ Index Only Scan using t_b_asc_idx on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((h)::double precision) < '1.2'::double precision)
+   Heap Fetches: 0
+(3 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+ cbrt
+------
+    1
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+                                QUERY PLAN
+---------------------------------------------------------------------------
+ Index Only Scan using t_b_asc_idx on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((h)::double precision) = '1'::double precision)
+   Heap Fetches: 0
+(3 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+ cbrt
+------
+    1
+(1 row)
+
+SET enable_seqscan = true;
+-- we prefer filtering rows from the seq scan instead of the index scan
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+                    QUERY PLAN
+--------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Filter: (yb_hash_code(h) < 4000)
+   Rows Removed by Filter: 9
+(3 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+-- we prefer filtering rows from the seq scan instead of the index scan
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+                    QUERY PLAN
+--------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Filter: (yb_hash_code(h) = 2675)
+   Rows Removed by Filter: 9
+(3 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+                                QUERY PLAN
+--------------------------------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((h)::double precision) < '1.2'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+ cbrt
+------
+    1
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+                               QUERY PLAN
+------------------------------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((h)::double precision) = '1'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+ cbrt
+------
+    1
+(1 row)
+
+---- HASH INDEX ON yb_hash_code(h), HASH INDEX ON cbrt(h) ----
+DROP INDEX t_b_asc_idx;
+CREATE INDEX t_b_hash_code_idx ON test_with_pk(yb_hash_code(h));
+CREATE INDEX t_b_cbrt_idx ON test_with_pk(cbrt(h));
+SET enable_seqscan = false;
+-- cannot use a hash index for a range clause on yb_hash_code(h) because it's ordered by yb_hash_code(yb_hash_code(h))
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+                    QUERY PLAN
+--------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Filter: (yb_hash_code(h) < 4000)
+   Rows Removed by Filter: 9
+(3 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+-- can use a hash index on yb_hash_code for a yb_hash_code equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+                                 QUERY PLAN
+----------------------------------------------------------------------------
+ Index Scan using t_b_hash_code_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(h) = 2675)
+(2 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+-- cannot use a hash index on cbrt for a cbrt range clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+                                QUERY PLAN
+--------------------------------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((h)::double precision) < '1.2'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+ cbrt
+------
+    1
+(1 row)
+
+-- can use a hash index on cbrt for a cbrt equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+                              QUERY PLAN
+-----------------------------------------------------------------------
+ Index Scan using t_b_cbrt_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (cbrt((h)::double precision) = '1'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+ cbrt
+------
+    1
+(1 row)
+
+SET enable_seqscan = true;
+-- cannot use a hash index for a range clause on yb_hash_code(h) because it's ordered by yb_hash_code(yb_hash_code(h))
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+                    QUERY PLAN
+--------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Filter: (yb_hash_code(h) < 4000)
+   Rows Removed by Filter: 9
+(3 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+-- can use a hash index on yb_hash_code for a yb_hash_code equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+                                 QUERY PLAN
+----------------------------------------------------------------------------
+ Index Scan using t_b_hash_code_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(h) = 2675)
+(2 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+-- cannot use a hash index on cbrt for a cbrt range clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+                                QUERY PLAN
+--------------------------------------------------------------------------
+ Seq Scan on test_with_pk (actual rows=1 loops=1)
+   Remote Filter: (cbrt((h)::double precision) < '1.2'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+ cbrt
+------
+    1
+(1 row)
+
+-- can use a hash index on cbrt for a cbrt equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+                              QUERY PLAN
+-----------------------------------------------------------------------
+ Index Scan using t_b_cbrt_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (cbrt((h)::double precision) = '1'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+ cbrt
+------
+    1
+(1 row)
+
+---- ASC INDEX ON yb_hash_code(h), ASC INDEX on cbrt(h) ----
+DROP INDEX t_b_hash_code_idx;
+DROP INDEX t_b_cbrt_idx;
+CREATE INDEX t_b_hash_code_asc_idx ON test_with_pk(yb_hash_code(h) ASC);
+CREATE INDEX t_b_cbrt_asc_idx ON test_with_pk(cbrt(h) ASC);
+SET enable_seqscan = false;
+-- can use the ascending index on yb_hash_code for an equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+                                   QUERY PLAN
+--------------------------------------------------------------------------------
+ Index Scan using t_b_hash_code_asc_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(h) < 4000)
+(2 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+-- can use the ascending index on yb_hash_code for an equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+                                   QUERY PLAN
+--------------------------------------------------------------------------------
+ Index Scan using t_b_hash_code_asc_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(h) = 2675)
+(2 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+-- can use the ascending index on cbrt for an equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+                                QUERY PLAN
+---------------------------------------------------------------------------
+ Index Scan using t_b_cbrt_asc_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (cbrt((h)::double precision) < '1.2'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+ cbrt
+------
+    1
+(1 row)
+
+-- can use the ascending index on cbrt for an equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+                                QUERY PLAN
+---------------------------------------------------------------------------
+ Index Scan using t_b_cbrt_asc_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (cbrt((h)::double precision) = '1'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+ cbrt
+------
+    1
+(1 row)
+
+SET enable_seqscan = true;
+-- for each case, we prefer to use the indexes instead of a seq scan
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+                                   QUERY PLAN
+--------------------------------------------------------------------------------
+ Index Scan using t_b_hash_code_asc_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(h) < 4000)
+(2 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+                                   QUERY PLAN
+--------------------------------------------------------------------------------
+ Index Scan using t_b_hash_code_asc_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (yb_hash_code(h) = 2675)
+(2 rows)
+
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+ yb_hash_code
+--------------
+         2675
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+                                QUERY PLAN
+---------------------------------------------------------------------------
+ Index Scan using t_b_cbrt_asc_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (cbrt((h)::double precision) < '1.2'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+ cbrt
+------
+    1
+(1 row)
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+                                QUERY PLAN
+---------------------------------------------------------------------------
+ Index Scan using t_b_cbrt_asc_idx on test_with_pk (actual rows=1 loops=1)
+   Index Cond: (cbrt((h)::double precision) = '1'::double precision)
+(2 rows)
+
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+ cbrt
+------
+    1
+(1 row)
diff --git a/src/postgres/src/test/regress/expected/yb_hash_code.out b/src/postgres/src/test/regress/expected/yb_hash_code.out
index d7ee07794080..c90ec98770d6 100644
--- a/src/postgres/src/test/regress/expected/yb_hash_code.out
+++ b/src/postgres/src/test/regress/expected/yb_hash_code.out
@@ -456,23 +456,6 @@ SELECT * FROM text_table WHERE yb_hash_code(hr) = 30;
  8646 | 8646 | 8646 | 8646 | 8646
 (1 row)
 
--- pushdown should not occur in this case but it should
--- operate as a normal index expression
-CREATE INDEX ybhashtjidx ON text_table (yb_hash_code(tj));
-EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT * FROM text_table WHERE yb_hash_code(tj) = 63;
-                             QUERY PLAN
---------------------------------------------------------------------
- Index Scan using ybhashtjidx on text_table (actual rows=1 loops=1)
-   Index Cond: (yb_hash_code(tj) = 63)
-(2 rows)
-
-SELECT * FROM text_table WHERE yb_hash_code(tj) = 63;
-  hr  |  ti  |  tj  |  i   |  j
-------+------+------+------+------
- 1363 | 1363 | 1363 | 1363 | 1363
-(1 row)
-
-DROP INDEX ybhashtjidx;
 -- testing pushdown on a secondary index with a text hash column
 CREATE INDEX textidx ON text_table (tj);
 EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT * FROM text_table WHERE yb_hash_code(tj) = 63;
diff --git a/src/postgres/src/test/regress/sql/yb_functional_index_multiple_column.sql b/src/postgres/src/test/regress/sql/yb_functional_index_multiple_column.sql
new file mode 100644
index 000000000000..6e8d49bc2cb3
--- /dev/null
+++ b/src/postgres/src/test/regress/sql/yb_functional_index_multiple_column.sql
@@ -0,0 +1,152 @@
+CREATE TABLE t AS SELECT x, x AS y, x AS z FROM generate_series(1, 10) x;
+
+CREATE INDEX t_hcx_hash_y_hash_idx ON t ((yb_hash_code(x), y) HASH);
+-- Query #2 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6); -- this one uses index successfully on master (because it has recheck)
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+
+DROP INDEX t_hcx_hash_y_hash_idx;
+CREATE INDEX t_hcx_asc_y_asc_idx ON t (yb_hash_code(x) ASC, y ASC);
+-- These should all use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+
+DROP INDEX t_hcx_asc_y_asc_idx;
+CREATE INDEX t_hcx_hash_y_asc_idx ON t (yb_hash_code(x) HASH, y ASC);
+-- Query #2 and #4 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+
+DROP INDEX t_hcx_hash_y_asc_idx;
+CREATE INDEX t_y_hash_hcx_asc_idx ON t (y HASH, yb_hash_code(x) ASC);
+-- Query #2 and #3 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+
+DROP INDEX t_y_hash_hcx_asc_idx;
+CREATE INDEX t_cbrtx_hash_y_hash_idx ON t ((cbrt(x), y) HASH);
+-- Query #2 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y < 2;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y = 1;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y = 1;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y < 2;
+
+DROP INDEX t_cbrtx_hash_y_hash_idx;
+CREATE INDEX t_cbrtx_asc_y_asc_idx ON t (cbrt(x) ASC, y ASC);
+-- These should all use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y < 2;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y = 1;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y = 1;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y < 2;
+
+DROP INDEX t_cbrtx_asc_y_asc_idx;
+CREATE INDEX t_cbrtx_hash_y_asc_idx ON t (cbrt(x) HASH, y ASC);
+-- Query #2 and #4 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y < 2;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y = 1;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y = 1;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y < 2;
+
+DROP INDEX t_cbrtx_hash_y_asc_idx;
+CREATE INDEX t_y_hash_cbrtx_asc_idx ON t (y HASH, cbrt(x) ASC);
+-- Query #2 and #3 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y < 2;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y = 1;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) < 1.2 AND y = 1;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(x), y FROM t WHERE cbrt(x) = 1 AND y < 2;
+
+DROP INDEX t_y_hash_cbrtx_asc_idx;
+CREATE INDEX t_x_hash_y_hash_idx ON t ((x, y) HASH);
+-- Query #2 should be able to use the index, but doesn't (even before this diff)
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+
+DROP INDEX t_x_hash_y_hash_idx;
+CREATE INDEX t_x_hash_y_asc_idx ON t (x HASH, y ASC);
+-- All should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+-- EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6); -- TODO: #17043
+-- EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6); -- TODO: #17043
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+
+DROP INDEX t_x_hash_y_asc_idx;
+CREATE INDEX t_y_hash_x_asc_idx ON t (y HASH, x ASC);
+-- Query #2 and #3 should use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+
+DROP INDEX t_y_hash_x_asc_idx;
+CREATE INDEX t_x_asc_y_asc_idx ON t (x ASC, y ASC);
+-- These should all use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+
+DROP INDEX t_x_asc_y_asc_idx;
+CREATE INDEX t_x_hash_y_hashcode ON t (x HASH, yb_hash_code(y));
+-- These should all be able to use the index, with queries #1-4 needing to filter to satisfy the y constraint
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y) FROM t WHERE yb_hash_code(x) < 4000 AND yb_hash_code(y) > 4;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y) FROM t WHERE yb_hash_code(x) = 2675 AND yb_hash_code(y) = 2675;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y) FROM t WHERE yb_hash_code(x) < 4000 AND yb_hash_code(y) = 2675;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y) FROM t WHERE yb_hash_code(x) = 2675 AND yb_hash_code(y) > 4;
+
+DROP INDEX t_x_hash_y_hashcode;
+CREATE INDEX t_x_hash_yz_hashcode ON t (x HASH, yb_hash_code(y, z));
+-- These should all be able to use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675;
+-- These should be all be able to use the index, with a filter to satisfy the y constraint
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y > 4;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) < 4000 AND y IN (5, 6);
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y > 4;
+-- These should all be able to use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y, z) FROM t WHERE yb_hash_code(x) > 40000 AND yb_hash_code(y, z) < 2500;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y, z) FROM t WHERE yb_hash_code(x) = 40623 AND yb_hash_code(y, z) = 2181;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y, z) FROM t WHERE yb_hash_code(x) > 40000 AND yb_hash_code(y, z) < 2500;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x), yb_hash_code(y, z) FROM t WHERE yb_hash_code(x) = 40623 AND yb_hash_code(y, z) = 2181;
+
+DROP INDEX t_x_hash_yz_hashcode;
+CREATE INDEX t_xy_yb_hash_code ON t (yb_hash_code(x, y));
+-- Of the following, only the query with an equality clause on yb_hash_code(x, y) should be able to use the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x, x) FROM t WHERE yb_hash_code(x, x) = 2181;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x, x) FROM t WHERE yb_hash_code(x, x) < 2500;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x, y) FROM t WHERE yb_hash_code(x, y) = 2181;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x, y) FROM t WHERE yb_hash_code(x, y) < 2500;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(y, x) FROM t WHERE yb_hash_code(y, x) = 2181;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(y, x) FROM t WHERE yb_hash_code(y, x) < 2500;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(y, y) FROM t WHERE yb_hash_code(y, y) = 2181;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(y, y) FROM t WHERE yb_hash_code(y, y) < 2500;
+
+DROP INDEX t_xy_yb_hash_code;
+-- In general, a query on yb_hash_code(x) < 4000 could use either the (x HASH)
+-- column of the index or the (yb_hash_code(x) ASC) part of the index.
+-- We want to ensure that both are allowed, and the presence of one does not
+-- forbid the use of the other. In this index, even though we have yb_hash_code(x|y) columns,
+-- we won't use them because the index is ordered by (x HASH, y ASC) first.
+CREATE INDEX t_complex_idx ON t (y HASH, y ASC, yb_hash_code(x) ASC, yb_hash_code(y) ASC);
+-- These queries will not use the index because yb_hash_code(x) is too deep in the index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x) FROM t WHERE yb_hash_code(x) < 4000;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(x) FROM t WHERE yb_hash_code(x) = 2675;
+-- These queries will use the index because the (y HASH) column can answer the query.
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(y) FROM t WHERE yb_hash_code(y) < 4000;
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(y) FROM t WHERE yb_hash_code(y) = 2675;
+
+DROP TABLE t;
diff --git a/src/postgres/src/test/regress/sql/yb_functional_indexes.sql b/src/postgres/src/test/regress/sql/yb_functional_indexes.sql
new file mode 100644
index 000000000000..59a14b51f768
--- /dev/null
+++ b/src/postgres/src/test/regress/sql/yb_functional_indexes.sql
@@ -0,0 +1,222 @@
+CREATE TABLE test_with_pk (a INT PRIMARY KEY, h INT);
+INSERT INTO test_with_pk SELECT x, x FROM generate_series(1, 10) x;
+
+-- This test verifies:
+--  * yb_hash_code range queries
+--  * yb_hash_code equality queries
+--  * cbrt range queries
+--  * cbrt equality queries
+-- on the following cases
+--  * on the primary key
+--  * on a regular column
+--  * on a regular column that has a hash index
+--  * on a regular column that has an asc index
+--  * on a regular column that has a hash index on yb_hash_code and a hash
+--    index on cbrt
+--  * on a regular column that has an asc index on yb_hash_code and an asc
+--    index on cbrt
+-- cbrt was selected as an example of a simple, standard function, not because
+-- of any special attributes. For each of these 4 * 6 cases, they are tested
+-- with seqscans disabled and with seqscans enabled. This documents their
+-- preferred plan, and also ensures that if the query planner allows them to
+-- use an index, the result is still correct.
+
+---- PRIMARY KEY ----
+SET enable_seqscan = false;
+
+-- we can pushdown the yb_hash_code call to the pk index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) < 4000;
+SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) < 4000;
+
+-- we can pushdown the yb_hash_code call to the pk index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) = 2675;
+SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) = 2675;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) < 1.2;
+SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) < 1.2;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) = 1;
+SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) = 1;
+
+SET enable_seqscan = true;
+
+-- we can pushdown the yb_hash_code call to the pk index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) < 4000;
+SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) < 4000;
+
+-- we can pushdown the yb_hash_code call to the pk index
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) = 2675;
+SELECT yb_hash_code(a) FROM test_with_pk WHERE yb_hash_code(a) = 2675;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) < 1.2;
+SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) < 1.2;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) = 1;
+SELECT cbrt(a) FROM test_with_pk WHERE cbrt(a) = 1;
+
+---- REGULAR COLUMN ----
+SET enable_seqscan = false;
+-- for these queries, we use seqscan (even when disabled)
+-- because there is no other option
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+
+---- HASH INDEX ON THE COLUMN ----
+CREATE INDEX t_b_hash_idx ON test_with_pk(h);
+SET enable_seqscan = false;
+
+-- we can pushdown yb_hash_code(h) on a hash index on h because the index is ordered by hash code
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+
+-- we can pushdown yb_hash_code(h) on a hash index on h because the index is ordered by hash code
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+
+SET enable_seqscan = true;
+
+-- we prefer using the index over a seq scan
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+
+-- we prefer using the index over a seq scan
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+
+---- ASC INDEX ON THE COLUMN ----
+DROP INDEX t_b_hash_idx;
+CREATE INDEX t_b_asc_idx ON test_with_pk(h ASC);
+
+SET enable_seqscan = false;
+
+-- cannot pushdown a range yb_hash_code(h) clause on a ascending index on h because the index is not ordered by hash code
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+
+-- cannot pushdown an equality yb_hash_code(h) clause on a ascending index on h because the index is not ordered by hash code
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+
+SET enable_seqscan = true;
+
+-- we prefer filtering rows from the seq scan instead of the index scan
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+
+-- we prefer filtering rows from the seq scan instead of the index scan
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+
+---- HASH INDEX ON yb_hash_code(h), HASH INDEX ON cbrt(h) ----
+DROP INDEX t_b_asc_idx;
+CREATE INDEX t_b_hash_code_idx ON test_with_pk(yb_hash_code(h));
+CREATE INDEX t_b_cbrt_idx ON test_with_pk(cbrt(h));
+
+SET enable_seqscan = false;
+
+-- cannot use a hash index for a range clause on yb_hash_code(h) because it's ordered by yb_hash_code(yb_hash_code(h))
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+
+-- can use a hash index on yb_hash_code for a yb_hash_code equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+
+-- cannot use a hash index on cbrt for a cbrt range clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+
+-- can use a hash index on cbrt for a cbrt equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+
+SET enable_seqscan = true;
+
+-- cannot use a hash index for a range clause on yb_hash_code(h) because it's ordered by yb_hash_code(yb_hash_code(h))
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+
+-- can use a hash index on yb_hash_code for a yb_hash_code equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+
+-- cannot use a hash index on cbrt for a cbrt range clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+
+-- can use a hash index on cbrt for a cbrt equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+
+---- ASC INDEX ON yb_hash_code(h), ASC INDEX on cbrt(h) ----
+DROP INDEX t_b_hash_code_idx;
+DROP INDEX t_b_cbrt_idx;
+CREATE INDEX t_b_hash_code_asc_idx ON test_with_pk(yb_hash_code(h) ASC);
+CREATE INDEX t_b_cbrt_asc_idx ON test_with_pk(cbrt(h) ASC);
+
+SET enable_seqscan = false;
+
+-- can use the ascending index on yb_hash_code for an equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+
+-- can use the ascending index on yb_hash_code for an equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+
+-- can use the ascending index on cbrt for an equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+
+-- can use the ascending index on cbrt for an equality clause
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+
+SET enable_seqscan = true;
+-- for each case, we prefer to use the indexes instead of a seq scan
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) < 4000;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+SELECT yb_hash_code(h) FROM test_with_pk WHERE yb_hash_code(h) = 2675;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) < 1.2;
+
+EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
+SELECT cbrt(h) FROM test_with_pk WHERE cbrt(h) = 1;
diff --git a/src/postgres/src/test/regress/sql/yb_hash_code.sql b/src/postgres/src/test/regress/sql/yb_hash_code.sql
index e3ed9d57fd94..c5b709c03d67 100644
--- a/src/postgres/src/test/regress/sql/yb_hash_code.sql
+++ b/src/postgres/src/test/regress/sql/yb_hash_code.sql
@@ -102,13 +102,6 @@ INSERT INTO text_table SELECT i::TEXT, i::TEXT, i::TEXT, i, i FROM generate_seri
 EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT * FROM text_table WHERE yb_hash_code(hr) = 30;
 SELECT * FROM text_table WHERE yb_hash_code(hr) = 30;
 
--- pushdown should not occur in this case but it should
--- operate as a normal index expression
-CREATE INDEX ybhashtjidx ON text_table (yb_hash_code(tj));
-EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT * FROM text_table WHERE yb_hash_code(tj) = 63;
-SELECT * FROM text_table WHERE yb_hash_code(tj) = 63;
-DROP INDEX ybhashtjidx;
-
 -- testing pushdown on a secondary index with a text hash column
 CREATE INDEX textidx ON text_table (tj);
 EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT * FROM text_table WHERE yb_hash_code(tj) = 63;
diff --git a/src/postgres/src/test/regress/yb_proc_schedule b/src/postgres/src/test/regress/yb_proc_schedule
index be755934cee4..0e55aa72f25b 100644
--- a/src/postgres/src/test/regress/yb_proc_schedule
+++ b/src/postgres/src/test/regress/yb_proc_schedule
@@ -5,4 +5,6 @@
 ####################################################################################################
 test: yb_hash_code
 test: yb_function
+test: yb_functional_indexes
+test: yb_functional_index_multiple_column
 test: yb_get_current_transaction_priority
